# Flamingo Feature Overview

* lightweight, powerful and fast (web) application framework.
* flexible configuration concepts via yml, supporting different contexts
* powerful dependency injection (see dingo):

    * inject configurations
    * automatic injection of struct types
    * automatic provider generation
    * flexible bindings with tagging support for binding slices and maps etc
    * overloading bindings
    * scope bindings (singleton etc)
* flexible routing with support for prefix-routes, powerful path notation and flexible assignments of actions.
* build in support for distributed tracing (opencensus)
* powerful templating based on pug templates and flamingo-carotene:

    * supporting mixins and easy scripting
    * allows to structure templates with reusable parts - for example following the "atomic design pattern"
    * allows for separate independent frontend build pipeline. (flamingo-carotene comes with a build pipeline that can be used out of the box)
    * super fast parallel template rendering supported
    * support for building progressive web apps
* session and logging usage made easy
* Growing set of tested and proven core modules, e.g. for

    * localisation
    * form handling
    * authentication
    * ... 
* Opinionated structures for Flamingo modules, that implements the pattern of domain driven design and ports and adapters.
* Full featured flamingo-commerce modules that empowers you to build flexible e-commerce applications on top of any (micro) service-architecture.
  

 
